#!/usr/bin/perl
#
# $Id: cleanup.pl,v 1.5 1998/05/14 11:54:05 wralph Exp $
#
#  Script to clean up /LOG directory to prevent loss of data due to a disk
#  partition filling up. This script will be run by fetchem nightly.
#  
#  Written by Bill Ralph 2/24/98
#  Re-written by Bill Ralph in Perl 3/12/98
#
# Set up some variables.
#
use Getopt::Long;
use POSIX qw(strftime);
#
$ENV{PATH} = "/bin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/logger";
#
# Set the date to clean to 2 days + 15 minutes ago.
#
$clean_date=strftime("%y%m%d", localtime(time-2*24*60*60-15*60));
chomp($clean_date);
$SENSOR="sensor01";
$SENSOR_DIR="/LOG";
#
sub usage {
        print "Usage: cleanup.pl [-debug] -d CLEAN_DATE -n SENSOR.\n";
        exit 2;
}
#
#	Parse the parameters.
#
&GetOptions("debug", \$debug, "d:s", \$clean_date, "n:s", \$SENSOR);
##
if ( $debug )
{
   print "d = $clean_date \n";
   print "n = $SENSOR \n";
}
#
#
#  Rid ourselves of standard output and error to prevent tons of mail messages
#  from cron.
#
if ( $debug )
{
   open(STDOUT, ">>/tmp/cleanup.log");
   select STDOUT; $| = 1;              # make unbuffered
} else {
   open(STDOUT, ">>/dev/null");
   select STDOUT; $| = 1;
}
open(STDERR, ">&STDOUT");
select STDERR; $| = 1;              # make unbuffered
#
# Writer a marker to the log file.
#
$marker=strftime("%c", localtime(time));
chomp $marker;
print STDOUT $marker;
foreach $param ($0, @ARGV) {
   printf " %s", $param;
}
print STDOUT "\n";
#  No need to check parameter validity. Unspecified parameters assume their
#  default values: $clean_date = 3 days ago; $SENSOR = firewall.
#
#
#
# Remove the files matching our CLEAN_DATE
#
$file_pat="tcp.$clean_date??.gz";
$cmd="df $SENSOR_DIR;rm $SENSOR_DIR/$file_pat;df $SENSOR_DIR";
$cmd='"' . $cmd . '"';
if ( $debug )
{
   print STDOUT "Removing $SENSOR_DIR/$file_pat from $SENSOR.\n";
   print STDOUT ("ssh -l root $SENSOR $cmd\n");
} else {
   print STDOUT ("ssh -l root $SENSOR $cmd\n");
   system ("ssh -l root $SENSOR $cmd");
}
#
