#!/usr/bin/perl
#
#file: frames.pl

use CGI qw/:standard/;
use CGI::Carp qw(fatalsToBrowser);
use POSIX qw(strftime);
use Time::Local;
#
$today = strftime("%a %b %d, %Y - %T", localtime(time));
$shadow_prefix = strftime("GG%y%m%d.", localtime(time));
print header,
start_html(-title=>'Create an Incident Report',
           -base=>'http://www.goodguys.com/',
           -author=>'icu@goodguys.com',
           -background=>'/images/grayback.gif');
if (!param) {
   print h3({-align=>CENTER}, 
   "Goodguys Incorporated - Network Detection Report"),
   start_form(-target=>'answer'),
   "Goodguys Incident Report No.: ",
   textfield(-name=>'rep_num',
             -size=>15,
             -value=>$shadow_prefix),
   p(),
   "   Mail Recipients: ",
   textfield(-name=>'mailto',
             -size=>60,
             -value=>'IR@mailhost.goodguys.com'),
   p(),
   "1. Report Date: $today", 
   p(),
   "2. Incident Date: ",
   textfield(-name=>'inci_date',
             -size=>20),
   p(),
   "3. Type of Incident: ",
   scrolling_list(-name=>'inci_type',
                  -size=>1,
                  -values=>['Denial of Service Attack', 'Smurf Attack',
                  'Land Attack', 'IMAP Attack', 'Telnet Attack', 'Port Scan',
                  'RPC/Portmap Attack', 'Sendmail Attack', 'Boogie-Man Attack',
                  'Heart Attack', 'A Tic Attack', 'Knight Attack', 
                  'Pre-Dawn Attack', 'Attack of the Killer Tomatoes']),
   p(),
   "4. Individuals Involved: Source: ",
   textfield(-name=>'indi_source',
             -size=>35),
   "Target(s): ",
   textfield(-name=>'indi_target',
             -size=>35),
   p(),
   "5. Cost of this Incident: ",
   textfield(-name=>'inci_cost',
             -size=>70),
   p(),
   "6. Summary of Incident and Investigation Results: ",
   textarea(-name=>'summary',
            -rows=>10,
            -cols=>90,
            -wrap=>phsical),
   p(),
   submit,
   end_form;
} else {
   $rep_no = param('rep_num');
   $inci_date = param('inci_date');
   $inci_type = param('inci_type');
   $indi_source = param('indi_source');
   $indi_target = param('indi_target');
   $inci_cost = param('inci_cost');
   $inci_sum = param('summary');
   $mail_file = "/tmp/IR_mail_$$";
   open (MAIL, ">$mail_file");
   print MAIL " Report Number: $rep_no\n",
   " Report Date:   $today\n",
   " Incident Date: $inci_date\n",
   " Incident Type: $inci_type\n",
   " Individuals Involved - Source: $indi_source, Target: $indi_target\n",
   " Incident Cost: $inci_cost\n",
   " Summary: $inci_sum\n";
   close(MAIL);
   print h1("Your IR is in mailhost:$mail_file"),
   " Report Number: ",em($rep_no),
   " Report Date:   ",em($today),
   " Incident Date: ",em($inci_date),
   " Incident Type: ",em($inci_type),
   " Individuals Involved - Source: ",em($indi_source), 
   "Target: ",em($indi_target),
   " Incident Cost: ",em($inci_cost),
   " Summary: ",em($inci_sum);
}
print end_html;
