#!/usr/bin/perl
#
#file: frames.pl

use CGI qw/:standard/;
use CGI::Carp qw(fatalsToBrowser);
use POSIX qw(strftime);
use Time::Local;
#
%month_no = (
   "Jan" => 0, "Feb" => 1, "Mar" => 2, "Apr" => 3, "May" => 4, "Jun" => 5,
   "Jul" => 6, "Aug" => 7, "Sep" => 8, "Oct" => 9, "Nov" => 10, "Dec" => 11);
$today_mday = strftime("%d", localtime(time));
$today_month = strftime("%h", localtime(time));
$today_year = strftime("%Y", localtime(time));
print header,
start_html(-title=>'Intrusion Detection pattern search',
           -base=>'http://www.goodguys.com/',
           -author=>'icu@goodguys.com',
           -background=>'/images/grayback.gif');
if (!param) {
   print h1({-align=>CENTER}, "Search for a pattern in a day's sensor logs."),
   start_form(),
   "Site: ", 
   radio_group(-name=>'site',
               -values=>['Site1','Site2','Site3','Site4'],
               -defaults=>['Site1']),
   p(),
   "Host Name Lookup: ", 
   radio_group(-name=>'nslookup',
               -values=>['Yes','No'],
               -default=>'Yes'),
   p(),
   "Year: ",
   popup_menu(-name=>'year',
              -values=>['1997','1998','1999','2000','2001'],
              -default=>$today_year),
   "Month: ",
   popup_menu(-name=>'month',
              -values=>['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep',
                        'Oct','Nov','Dec'],
              -default=>$today_month),
   "Day of Month: ",
   popup_menu(-name=>'day',
              -values=>['1','2','3','4','5','6','7','8','9','10','11','12','13',
                        '14','15','16','17','18','19','20','21','22','23','24',
                        '25','26','27','28','29','30','31'],
              -default=>$today_mday),
   p(),
   "Search for a particular IP or 'host': ",
   textfield(-name=>'hostname',
             -size=>30),
   radio_group(-name=>'host_mod',
               -values=>['src','dst','either'],
               -default=>'either'),
   p(),
   radio_group(-name=>'port_join',
               -values=>['and','or'],
               -default=>'or'),
   "Search for a particular 'port': ",
   textfield(-name=>'port_num',
             -size=>10),
   radio_group(-name=>'port_mod',
               -values=>['src','dst','either'],
               -default=>'either'),
   p(),
   radio_group(-name=>'net_join',
               -values=>['and','or'],
               -default=>'or'),
   "Search for a particular IP or 'net': ",
   textfield(-name=>'netname',
             -size=>30),
   radio_group(-name=>'net_mod',
               -values=>['src','dst','either'],
               -default=>'either'),
   p(),
   radio_group(-name=>'gen_join',
               -values=>['and','or'],
               -default=>'or'),
   "Search for a general TCPDUMP format filter': ",
   textfield(-name=>'gen_pat',
             -size=>30),
   p(),
   submit,
   end_form;
} else {
   $date = strftime("%y%m%d", 0, 0, 0, param('day'), $month_no{param('month')}, 
                    param('year'), 0, 0, 0);
   $site = param('site');
   $pattern = "";
   if (param('hostname')) {
      $pattern .= (param('host_mod') . " ")  if (param('host_mod') ne "either");
      $pattern .= "host " . param('hostname') . " ";
   }
   if (param('port_num')) {
      $pattern .= (param('port_join' . " ")) if ($pattern);
      $pattern .= (param('port_mod'). " ") if (param('port_mod') ne "either");
      $pattern .= "port " . param('port_num') . " ";
   }
   if (param('netname')) {
      $pattern .= (param('net_join') . " ") if ($pattern);
      $pattern .= (param('net_mod') . " ")  if (param('net_mod') ne "either");
      $pattern .= "net " . param('netname') . " ";
   }
   if (param('gen_pat')) {
      $pattern .= (param('gen_join') . " ") if ($pattern);
      $pattern .= " " . param('gen_pat') . " ";
   }
   $lookup = (param('nslookup') eq 'Yes')?"":"-n";
   $cmd = "/usr/local/logger/one_day_pat.pl $lookup -d $date -l $site -p '$pattern'";
   print h1("Your answers: "),
   " Site: ",em(param('site')),
   " Host lookup: ",em(param('nslookup')),
   " Date: ",em($date),
   " Pattern: ",em($pattern),
#   "$cmd",
   p();
   print STDOUT "<PRE>";
   open(SEARCH, "$cmd|") || die "Can't open search script: $!\n" ;
   while (<SEARCH>) {
      print STDOUT $_;
   }
   print STDOUT "</PRE>";
}
print end_html;
