#!/usr/bin/perl
#
# $Id: pat_match.pl,v 1.2 1998/04/29 17:58:58 wralph Exp $
#
#  Script to scan a tcpdump compressed hourly file using a command line 
#  furnished pattern match. 
#  
#  Written by Bill Ralph 3/11/98
#
# Set up some variables.
#
use Getopt::Long;
use POSIX qw(strftime);
#
$ENV{PATH} = "/bin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/logger";
$pdir="/usr/local/logger";
$filters="/usr/local/logger/filters";
$logger_location="Site1";

sub usage {
	print "Usage: pat_match.pl [-debug] -n -d SNIFDATE -l LOGGER_LOCATION -p PATTERN\n";
	exit 2;
}
#
#	Parse the parameters.
#
#
&GetOptions("debug", \$debug, "n", \$no_lookup_flag, "d:s", \$snifdate, "l:s", \$logger_location,"p=s" , \$pattern);
##
if ($debug) {
   print "n = $no_lookup_flag \n";
   print "d = $snifdate \n";
   print "l = $logger_location \n";
   print "p = $pattern \n";
}
#
#  Check parameter validity.
#
if ("$snifdate" eq "" or "$logger_location" eq "" or "$pattern" eq "")
{
	usage();

}
#
#  Set the no_lookup_flag to -n for tcpdump if it was specified on the calling
#  parameter list.
#

$no_lookup_flag = ($no_lookup_flag eq "1") ?"-n":"";
#
#  Break up the "snifdate" into its useful components.
#
$year=substr($snifdate,0,2);
$mon=substr($snifdate,2,2) - 1;
$mday=substr($snifdate,4,2);
$dir=strftime("%h%d", 0, 0, 0, $mday, $mon, $year, 0, 0, 0);

if ($debug) {
   print "dir = $dir \n";
}
#
##
## Call tcpdump to read the uncompressed file and detect bad stuff.
##
$zipped_file="/LOG/$logger_location/$dir/tcp.$snifdate.gz";
$pattern='"'.$pattern.'"';
if ($debug) {
   print("gunzip -c $zipped_file | tcpdump $no_lookup_flag -r - $pattern\n");
} else {
   exec("gunzip -c $zipped_file | tcpdump $no_lookup_flag -r - $pattern");
}
#
