#!/bin/sh
# This is a shell archive (produced by GNU sharutils 4.2).
# To extract the files from this archive, save it to some FILE, remove
# everything before the `!/bin/sh' line above, then type `sh FILE'.
#
# Made on 1998-04-30 10:44 EDT by <wralph@apollo13.nswc.navy.mil>.
# Source directory was `/home/wralph/SANS/tmp'.
#
# Existing files will *not* be overwritten unless `-c' is specified.
#
# This shar contains:
# length mode       name
# ------ ---------- ------------------------------------------
#   1800 -rw-r--r-- README.scripts
#   1750 -rwxr-xr-x start_logger.pl
#   1029 -rwxr-xr-x stop_logger.pl
#   1269 -rwxr-xr-x tcpdump.driver.pl
#    860 -rw-r--r-- variables.ph
#
save_IFS="${IFS}"
IFS="${IFS}:"
gettext_dir=FAILED
locale_dir=FAILED
first_param="$1"
for dir in $PATH
do
  if test "$gettext_dir" = FAILED && test -f $dir/gettext \
     && ($dir/gettext --version >/dev/null 2>&1)
  then
    set `$dir/gettext --version 2>&1`
    if test "$3" = GNU
    then
      gettext_dir=$dir
    fi
  fi
  if test "$locale_dir" = FAILED && test -f $dir/shar \
     && ($dir/shar --print-text-domain-dir >/dev/null 2>&1)
  then
    locale_dir=`$dir/shar --print-text-domain-dir`
  fi
done
IFS="$save_IFS"
if test "$locale_dir" = FAILED || test "$gettext_dir" = FAILED
then
  echo=echo
else
  TEXTDOMAINDIR=$locale_dir
  export TEXTDOMAINDIR
  TEXTDOMAIN=sharutils
  export TEXTDOMAIN
  echo="$gettext_dir/gettext -s"
fi
touch -am 1231235999 $$.touch >/dev/null 2>&1
if test ! -f 1231235999 && test -f $$.touch; then
  shar_touch=touch
else
  shar_touch=:
  echo
  $echo 'WARNING: not restoring timestamps.  Consider getting and'
  $echo "installing GNU \`touch', distributed in GNU File Utilities..."
  echo
fi
rm -f 1231235999 $$.touch
#
if mkdir _sh18829; then
  $echo 'x -' 'creating lock directory'
else
  $echo 'failed to create lock directory'
  exit 1
fi
# ============= README.scripts ==============
if test -f 'README.scripts' && test "$first_param" != -c; then
  $echo 'x -' SKIPPING 'README.scripts' '(file already exists)'
else
  $echo 'x -' extracting 'README.scripts' '(text)'
  sed 's/^X//' << 'SHAR_EOF' > 'README.scripts' &&
X
This archive contains the sensor-side files of the CID (Cooperative 
Intrusion Detection) package from NSWC. Rewritten in Perl by Olav
Kolbu <olav.kolbu@usit.uio.no> from the original shell scripts by
Bill Ralph. It assumes you have the binary files handy (tcpdump and
gzip).
X
The perl scripts all require perl 5. Edit them and change the
first line if your perl5 is not '/usr/bin/perl'. You MAY get away
with using perl4, but this has not been tested.
X
The most important thing to remember is to change the 'variables.ph'
file. Note that the file itself must either be placed in a directory 
in your perl's include path (see 'perl5 -V') or you need to edit the 
three *.pl files and change the line 
X   unshift(@INC, "/logger/sensor");
near the top of the files to point to the directory where you have
placed 'variables.ph'.
X
Other than that the one thing likely to break on a new platform
is the way start_logger.pl tries to extract the PID of the newly
started tcpdump from the process table (using 'ps'). 
X
The files in this archive:
X
README.scripts      - This file
tcpdump.driver.pl   - The script that should go into your crontab. 
X                      Basically it should stop tcpdump, rotate logs
X                      and restart tcpdump every hour.
start_logger.pl     - The script used by tcpdump.driver.pl to
X                      rotate the logs and start tcpdump.
stop_logger.pl      - The script used by tcpdump.driver.pl to
X                      stop the running tcpdump.
variables.ph        - The include file containing all the 
X                      site-changable variables. Typically various
X                      directories and filenames used by the scripts 
X                      to locate logfiles, tcpdump etc etc.
X                      MAKE SURE YOU CHANGE THIS FILE!
X
SHAR_EOF
  $shar_touch -am 0430081398 'README.scripts' &&
  chmod 0644 'README.scripts' ||
  $echo 'restore of' 'README.scripts' 'failed'
  if ( md5sum --help 2>&1 | grep 'sage: md5sum \[' ) >/dev/null 2>&1 \
  && ( md5sum --version 2>&1 | grep -v 'textutils 1.12' ) >/dev/null; then
    md5sum -c << SHAR_EOF >/dev/null 2>&1 \
    || $echo 'README.scripts:' 'MD5 check failed'
12c4f1530a0b09a455e12ee4bd7ace41  README.scripts
SHAR_EOF
  else
    shar_count="`LC_ALL= LC_CTYPE= LANG= wc -c < 'README.scripts'`"
    test 1800 -eq "$shar_count" ||
    $echo 'README.scripts:' 'original size' '1800,' 'current size' "$shar_count!"
  fi
fi
# ============= start_logger.pl ==============
if test -f 'start_logger.pl' && test "$first_param" != -c; then
  $echo 'x -' SKIPPING 'start_logger.pl' '(file already exists)'
else
  $echo 'x -' extracting 'start_logger.pl' '(text)'
  sed 's/^X//' << 'SHAR_EOF' > 'start_logger.pl' &&
#!/usr/bin/perl
#
# startup-wrapper for the tcpdump used in the CID tool.
#
# Author: Olav Kolbu <olav.kolbu@usit.uio.no>
#
# This code is hereby released into the public domain. It is released
# "as-is". All warranties disclaimed, implied or otherwise.
# 
X
# These are the external variables we need. This must be in a suitable
# directory.
unshift(@INC, "/logger/sensor");
require "variables.ph";
X
`cp $LOGDIR/snif.date.1 $LOGDIR/snif.date.2`;
`cp $LOGDIR/snif.date.0 $LOGDIR/snif.date.1`;
`cp $LOGDIR/snif.date $LOGDIR/snif.date.0`;
X
# Current date goes into a file for later use
$tmp = sprintf("%02d%02d%02d%02d", @T[5],@T[4]+1,@T[3],@T[2]);
`echo "$tmp" > $LOGDIR/snif.date`;
X
if ( -f $LOGPID )
{
X  chop($pid = `cat $LOGPID`);
X  if ( $pid && kill (0, int($pid)) )
X  {
X    print "$0: $LOGPROG is already running, aborting\n";
X    exit 1;
X  }
}
X
# Fire up the actual program. 
#
system("($LOGPROG -w - ip and not port 25 and not port 20 | $PROGLOC/gzip) > $TCPLOG 2>/dev/null&");
X
# Since the gzip is tagged on at the end of the command, we have to
# go through hoops to get the right PID for the LOGPROG.
# NB! This is by no means bulletproof! You might find that once in a while,
# the ps listing will not contain the line you're looking for. Odd that.
#
`ps -ef >/dev/null 2>/dev/null`;
if ( $? )
{
X  chop($pid = `ps -ax|grep "$LOGPROG"|grep -v grep|awk '{print \$1}'`);
}
else
{
X  chop($pid = `ps -ef|grep "$LOGPROG"|grep -v grep|awk '{print \$2}'`);
}
X
# Saves the new pid in the LOGPID file (hopefully we found it :-).
`echo "$pid" > $LOGPID`;
X
# And we let them know if we didn't find it, as something serious
# could be wrong.
X
if ( ! $pid )
{
X    print "$0: $LOGPROG may not be running, can't find pid in process table!\n";
X    exit 1;
}
SHAR_EOF
  $shar_touch -am 0430081098 'start_logger.pl' &&
  chmod 0755 'start_logger.pl' ||
  $echo 'restore of' 'start_logger.pl' 'failed'
  if ( md5sum --help 2>&1 | grep 'sage: md5sum \[' ) >/dev/null 2>&1 \
  && ( md5sum --version 2>&1 | grep -v 'textutils 1.12' ) >/dev/null; then
    md5sum -c << SHAR_EOF >/dev/null 2>&1 \
    || $echo 'start_logger.pl:' 'MD5 check failed'
56384e8395010e0ddbe844c9149de3b4  start_logger.pl
SHAR_EOF
  else
    shar_count="`LC_ALL= LC_CTYPE= LANG= wc -c < 'start_logger.pl'`"
    test 1750 -eq "$shar_count" ||
    $echo 'start_logger.pl:' 'original size' '1750,' 'current size' "$shar_count!"
  fi
fi
# ============= stop_logger.pl ==============
if test -f 'stop_logger.pl' && test "$first_param" != -c; then
  $echo 'x -' SKIPPING 'stop_logger.pl' '(file already exists)'
else
  $echo 'x -' extracting 'stop_logger.pl' '(text)'
  sed 's/^X//' << 'SHAR_EOF' > 'stop_logger.pl' &&
#!/usr/bin/perl
#
# shutdown-wrapper for the tcpdump used in the CID tool.
#
# Author: Olav Kolbu <olav.kolbu@usit.uio.no>
#
# This code is hereby released into the public domain. It is released
# "as-is". All warranties disclaimed, implied or otherwise.
# 
X
# These are the external variables we need
unshift(@INC, "/logger/sensor");
require "variables.ph";
X
if ( -f $LOGPID )
{
X  chop($pid = `cat $LOGPID`);
X  if ( ! $pid )
X  {
X    print "$0: Pid file '$LOGPID' bad or empty, aborting\n";
X    exit 1;
X  }
X  elsif ( kill (0, int($pid)) )
X  {
X    kill (9, int($pid));    
X    sleep(2); # Give the program some time to finish
X    if ( kill (0, int($pid)) )
X    {
X      print "$0: Unable to kill $LOGPROG, aborting\n";
X      exit 1;
X    }
X  }
X  else
X  {
X    print "$0: $LOGPROG was not running, aborting\n";
X    exit 1;
X  }
}
else
{
X  # Here we could have tried to locate the pid using 'ps' but
X  # we might zap a vital tcpdump run by some BOFH so we abstain.
X  print "$0: NO pid file '$LOGPID', aborting\n";
X  exit 1; 
}
X
Xexit 0;
SHAR_EOF
  $shar_touch -am 0430081098 'stop_logger.pl' &&
  chmod 0755 'stop_logger.pl' ||
  $echo 'restore of' 'stop_logger.pl' 'failed'
  if ( md5sum --help 2>&1 | grep 'sage: md5sum \[' ) >/dev/null 2>&1 \
  && ( md5sum --version 2>&1 | grep -v 'textutils 1.12' ) >/dev/null; then
    md5sum -c << SHAR_EOF >/dev/null 2>&1 \
    || $echo 'stop_logger.pl:' 'MD5 check failed'
6d52cd26c41472d572a751a998cb04d1  stop_logger.pl
SHAR_EOF
  else
    shar_count="`LC_ALL= LC_CTYPE= LANG= wc -c < 'stop_logger.pl'`"
    test 1029 -eq "$shar_count" ||
    $echo 'stop_logger.pl:' 'original size' '1029,' 'current size' "$shar_count!"
  fi
fi
# ============= tcpdump.driver.pl ==============
if test -f 'tcpdump.driver.pl' && test "$first_param" != -c; then
  $echo 'x -' SKIPPING 'tcpdump.driver.pl' '(file already exists)'
else
  $echo 'x -' extracting 'tcpdump.driver.pl' '(text)'
  sed 's/^X//' << 'SHAR_EOF' > 'tcpdump.driver.pl' &&
#!/usr/bin/perl
#
# main-wrapper for the tcpdump used in the CID tool. Goes in as a root
# cron job like this (runs every hour on the hour):
#
# 0 * * * * /<suitable path here>/tcpdump.driver.pl > /dev/null 2>&1
#
# The stop_logger.pl/start_logger.pl scripts complain if anything
# is wrong, so not much to do here except make sure the scripts we
# intend to run actually exist.
#
# Author: Olav Kolbu <olav.kolbu@usit.uio.no>
#
# This code is hereby released into the public domain. It is released
# "as-is". All warranties disclaimed, implied or otherwise.
# 
X
# These are the external variables we need
unshift(@INC, "/logger/sensor");
require "variables.ph";
X
# Refuse to do anything if stop_logger.pl or start_logger.pl isn't
# where we expect them to be.
die("'$PROGLOC/stop_logger.pl' not found, aborting\n") 
X  if ! -x "$PROGLOC/stop_logger.pl";
die("'$PROGLOC/start_logger.pl' not found, aborting\n") 
X  if ! -x "$PROGLOC/start_logger.pl";
X
# First, we stop the potentially running tcpdump program by calling our
# nifty stop_logger.pl script.
system("$PROGLOC/stop_logger.pl");
X
# Then we rotate a few logs, throw a few timestamps around and then
# fire up the new tcpdump. All in the equally nifty start_logger.pl script.
system("$PROGLOC/start_logger.pl");
SHAR_EOF
  $shar_touch -am 0430081098 'tcpdump.driver.pl' &&
  chmod 0755 'tcpdump.driver.pl' ||
  $echo 'restore of' 'tcpdump.driver.pl' 'failed'
  if ( md5sum --help 2>&1 | grep 'sage: md5sum \[' ) >/dev/null 2>&1 \
  && ( md5sum --version 2>&1 | grep -v 'textutils 1.12' ) >/dev/null; then
    md5sum -c << SHAR_EOF >/dev/null 2>&1 \
    || $echo 'tcpdump.driver.pl:' 'MD5 check failed'
e02ea43f0fd099b9f631c97c2478b801  tcpdump.driver.pl
SHAR_EOF
  else
    shar_count="`LC_ALL= LC_CTYPE= LANG= wc -c < 'tcpdump.driver.pl'`"
    test 1269 -eq "$shar_count" ||
    $echo 'tcpdump.driver.pl:' 'original size' '1269,' 'current size' "$shar_count!"
  fi
fi
# ============= variables.ph ==============
if test -f 'variables.ph' && test "$first_param" != -c; then
  $echo 'x -' SKIPPING 'variables.ph' '(file already exists)'
else
  $echo 'x -' extracting 'variables.ph' '(text)'
  sed 's/^X//' << 'SHAR_EOF' > 'variables.ph' &&
# Systemwide variables needed by the CID package
#
# Author: Olav Kolbu <olav.kolbu@usit.uio.no>
#
# This code is hereby released into the public domain. It is released
# "as-is". All warranties disclaimed, implied or otherwise.
#
X
# We need various timestamps all over the place
@T = localtime;
X
# The location of the scripts to be run on the sensor machine. Note 
# that gzip need to be in this location as well as the scripts!
$PROGLOC  = "/usr/local/bin";
X
# The full path to the 'tcpdump' program
$LOGPROG  = "/usr/local/bin/tcpdump";
X
# The log directory
$LOGDIR   = "/LOG";
X
# The PID file containing the pid of the last known 'tcpdump'
# Confusing variablename for a file but there ya go
$LOGPID  = "$LOGDIR/log.pid";
X
# The name of the current logfile
$tmp = sprintf("%02d%02d%02d%02d", @T[5],@T[4]+1,@T[3],@T[2]);
$TCPLOG   = "$LOGDIR/tcp.$tmp.gz";
X
SHAR_EOF
  $shar_touch -am 0430075298 'variables.ph' &&
  chmod 0644 'variables.ph' ||
  $echo 'restore of' 'variables.ph' 'failed'
  if ( md5sum --help 2>&1 | grep 'sage: md5sum \[' ) >/dev/null 2>&1 \
  && ( md5sum --version 2>&1 | grep -v 'textutils 1.12' ) >/dev/null; then
    md5sum -c << SHAR_EOF >/dev/null 2>&1 \
    || $echo 'variables.ph:' 'MD5 check failed'
1f50b2cf15d2e37c07b986e61985aa7c  variables.ph
SHAR_EOF
  else
    shar_count="`LC_ALL= LC_CTYPE= LANG= wc -c < 'variables.ph'`"
    test 860 -eq "$shar_count" ||
    $echo 'variables.ph:' 'original size' '860,' 'current size' "$shar_count!"
  fi
fi
rm -fr _sh18829
exit 0
