#!/bin/sh
#
set -x
# $Id: start_tcpdump_logger.sh,v 1.2 1998/04/24 18:31:49 wralph Exp $
#
# Script to start the tcpdump process for logging IP packets.
#
# Modified from old start_logger.sh script by Bill Ralph - 3/9/98
#
if [ ${DEBUG} ]
then
   set -x
   date '+DATE: %D TIME: %T'
   echo "Executing start_logger.sh"
fi
#
# save the date of the last file so we know what to process
#
cp $LOGDIR/snif.date.1 $LOGDIR/snif.date.2
cp $LOGDIR/snif.date.0 $LOGDIR/snif.date.1
cp $LOGDIR/snif.date $LOGDIR/snif.date.0
#
# we put the date of the snif file into here so we know what 
# to generate a signature for.
#
echo `date '+%y%m%d%H'` > $LOGDIR/snif.date
#
# See if the tcpdump process is already running.
#

test $LOGPID && TESTPID=`cat $LOGPID`

# echo -n $TESTPID | od -c
ps $LOGPID > /dev/null 2> /dev/null
if [ $? = 0 ]
then
	echo 1>&2 start_logger: $LOGPROG is already running
	exit 1
fi
date >> $LOGDIR/tcpdump.err

$LOGPROG -w - -F $PROGLOC/filter 2>>$LOGDIR/tcpdump.err | $GZIPPROG > $TCPLOG &
#
# Modified by Bill Ralph for tcpdump piped into gzip.
#
PID=`ps -ax | grep "tcpdump " | grep -v grep | awk '{print $1}'`
cp /dev/null $LOGPID
echo $PID > $LOGPID

