#! /bin/sh
#
# $Id: tcpdump.driver.sh,v 1.5 1998/04/27 14:13:43 wralph Exp $
#
#  Modified to automatically handle differences between SunOS and Linux.
#
#  Debugging option added by Bill Ralph, 1/9/98. Set DEBUG to some value
#  to log the trace of the shell script execution to /tmp/logger.out.
#
#DEBUG=1; export DEBUG
if [ ${DEBUG} ]
then
   if [ -f /tmp/logger.out ]
   then
      touch /tmp/logger.out
   fi
   exec >> /tmp/logger.out 2>&1
   set -x
   date '+DATE: %D TIME: %T'
   echo "Executing tcpdump.driver.sh"
fi
#
# tcpdump.driver.sh this program drives start_logger.sh and stop_logger.sh
# program is based on work by Chuck Smoko E81 1995 and modified by
# Stephen Northcut CD2S for AIDE loggers
# Last Modified: 11/25/97 tcpdump
#
OS=`uname -s`;
if [ "$OS" = "Linux" ]
then
   PERL=/usr/bin/perl
   PROGLOC=/usr/local/logger/sensor
   LOGPROG="/usr/sbin/tcpdump -i eth0"
   GZIPPROG=/bin/gzip
   GZIP="-c -f"
elif [ "$OS" = "SunOS" ]
then
   PERL=/usr/local/bin/perl
   PROGLOC=/usr/local/bin
   LOGPROG=/usr/local/bin/tcpdump
   GZIPPROG=/usr/local/bin/gzip
   GZIP=""
fi
LOGDIR=/LOG
LOGPID=$LOGDIR/log.pid
TCPLOG=$LOGDIR/tcp.`date '+%y%m%d%H'`.gz

export PERL PROGLOC LOGPROG LOGDIR LOGPID TCPLOG GZIPPROG GZIP
$PROGLOC/stop_tcpdump_logger.sh
#
# See if it's the midnight hour, if so run the perl script cycle_LOG.pl
# to insure we have enough space on the /LOG device for a while. 
#
# WDR 4/3/98
#
HOUR=`date +%H`
if [ "$HOUR" = "00" ]
then
   $PERL /usr/local/bin/cycle_log.pl
fi

if test -d $LOGDIR
then
	cd $LOGDIR
	touch $TCPLOG
	chmod 644 $TCPLOG
else
	echo 1>&2 newtcplog: $LOGPROG can not write to directory
	
fi


#
$PROGLOC/start_tcpdump_logger.sh
